package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rate.entity.RateFile;
import org.jeecg.modules.stm.rate.service.IRateFileService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 附件
 * @Author: jeecg-boot
 * @Date:   2023-09-26
 * @Version: V1.0
 */

@RestController
@RequestMapping("/rate/rateFile")
@Slf4j
public class RateFileController extends JeecgController<RateFile, IRateFileService> {
	@Autowired
	private IRateFileService rateFileService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateFile
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "附件-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<RateFile>> queryPageList(RateFile rateFile,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateFile> queryWrapper = QueryGenerator.initQueryWrapper(rateFile, req.getParameterMap());
		Page<RateFile> page = new Page<RateFile>(pageNo, pageSize);
		IPage<RateFile> pageList = rateFileService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateFile
	 * @return
	 */
	@AutoLog(value = "附件-添加")

	//@RequiresPermissions("rate:rate_file:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateFile rateFile) {
		rateFileService.save(rateFile);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateFile
	 * @return
	 */
	@AutoLog(value = "附件-编辑")

//	@RequiresPermissions("rate:rate_file:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateFile rateFile) {
		rateFileService.updateById(rateFile);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "附件-通过id删除")

	//@RequiresPermissions("rate:rate_file:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateFileService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "附件-批量删除")

	//@RequiresPermissions("rate:rate_file:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateFileService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "附件-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<RateFile> queryById(@RequestParam(name="id",required=true) String id) {
		RateFile rateFile = rateFileService.getById(id);
		if(rateFile==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateFile);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateFile
    */
    //@RequiresPermissions("rate:rate_file:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateFile rateFile) {
        return super.exportXls(request, rateFile, RateFile.class, "附件");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("rate:rate_file:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateFile.class);
    }

}
